#!/usr/bin/env python

import es, usermsg, playerlib, langlib

addon_path = es.getAddonPath("playermessages")
messages = {}
colors = ('#blue','#grey','#red','#team')
teams = {'#red':'#t','#blue':'#ct'}

info = es.AddonInfo()
info.name = "Player Connect Messages"
info.author = ".craziesT"
info.version = "RC1"
info.basename = "playermessages"

es.ServerVar('playermessages_version', info.version, 'Created by .craziesT').makepublic()

text = langlib.Strings(addon_path + '/config/languages.ini')

def load():
    importMessages(addon_path + '/config/messages.txt')
    
def importMessages(path):
    stream = open(path, 'r')
    lines = stream.readlines()
    stream.close()
    
    if lines:
        for line in filter(lambda line: not line.startswith('\\') and not line.startswith('//') and not line.startswith('\n'), lines):
            split = line.find('=')
            if split:
                steamid = line[:split].strip()
                message = str(line[split:]).replace('"', '').replace('=', '').strip()
                if message and steamid:
                    messages[str(steamid)] = message

def player_team(ev):
    userid = int(ev['userid'])
    steamid = es.getplayersteamid(userid)
    if steamid in messages:
        index = playerlib.getPlayer(userid).attributes['index']
        for player in es.getUseridList():
            saytext2(player, index, text('player message', {'player' : es.getplayername(userid), 'message' : messages[steamid]}, playerlib.getPlayer(player).get('lang')))
    
def saytext2(users, index, message):
    index, team = getIndex(index,message)
    message = message.replace('#default','\x01').replace('#green', '\x04').replace('#lightgreen','\x03')
    for color in colors:
        message = message.replace(color, '\x03')
    usermsg.saytext2(users,index,message)

def getIndex(index, message):
    if '#team' in message:
        return (index,es.getindexprop(index,'CBaseEntity.m_iTeamNum'))
    for color in teams:
        if color in message:
            players = playerlib.getPlayerList(teams[color])
            if players:
                return (players[0].index,players[0].team)
    if '#grey' in message:
        return (-1,0)
    return (0,0)